//=============================================================================
//||                             DirixleJacobi                               ||
//||                                                                         ||
//||                               Main.cpp                                  ||
//||                                                                         ||
//||                               by Dampir                                 ||
//=============================================================================

#include "CudaHeaders.cuh"

//  
int main(char mode, int choice)
{	
	int ch = 3;
	
switch (ch) {
	
	case 3: {
		fltParamOfMatrix fltMatrixInit;
		if (flt_input_from_file(&fltMatrixInit) == 1){ //      , 
			//----------------------------------------------------------------------------------
			printf("  Matrix width: %d\n", fltMatrixInit.N      );
            printf("  Matrix height: %d\n", fltMatrixInit.M     );
			printf("  Step X: %f\n", fltMatrixInit.hx          );
			printf("  Step Y: %f\n", fltMatrixInit.hy          );
			printf("  Epsilon: %f\n", fltMatrixInit.eps         );

			//----------------------------------------------------------------------------------
			int n = fltMatrixInit.N;
			int m = fltMatrixInit.M;
			//      u  N*N,     
			float *u         = new float [n * m];
			float *f         = new float [n * m];
			float *u_new     = new float [n * m];
			float *u_exact   = new float [n * m];
			//----------------------------------------------------------------------------------`
			flt_init_data_centr(u_exact, n, m, fltMatrixInit.hx, fltMatrixInit.hy);
			flt_init_exact_solv(u_exact, n, m, fltMatrixInit.hx, fltMatrixInit.hy);
			flt_init_right_side(f,       n, m, fltMatrixInit.hx, fltMatrixInit.hy);
			flt_init_data_centr(u,       n, m, fltMatrixInit.hx, fltMatrixInit.hy);
			flt_init_data_centr(u_new,   n, m, fltMatrixInit.hx, fltMatrixInit.hy);				
			//----------------------------------------------------------------------------------

			//   
            flt_write_matrix_to_file("u.txt",       u,       n, m);
			flt_write_matrix_to_file("u_new.txt",   u_new,   n, m);
			flt_write_matrix_to_file("u_exact.txt", u_exact, n, m);
			flt_write_matrix_to_file("f.txt",       f,       n, m);
			printf("\n\n**************************************\n");
			//----------------------------------------------------------------------------------

			//   
			test_compute_per_blocks(u, u_new, u_exact, f, fltMatrixInit);

			//    
	       // flt_write_matrix_to_file("Result.txt", fltMatrixInit.Result, n, m);
			delete[] u;
            delete[] f;
			delete[] u_new  ;
			delete[] u_exact;
		}
		else {
			printf("Reading error! Check file!\n\n");

			break;
		}
		break;
	}	 // end case 3	

}
	return 0;
} //  main
                     