//=============================================================================
//||                             DirixleJacobi                               ||
//||                                                                         ||
//||                          DirixleDefinitions.h                           ||
//||                                                                         ||
//||                               by Dampir                                 ||
//=============================================================================

#include <stdio.h>
#include <math.h>	
#include <string>
#include <stdlib.h>

const int blockSize1 = 4096/2;
const int threads = 64;
#define int_mult(x,y) x*y
#define inf 0x7f800000;

using namespace std; 

#define flt_PI (float)(4.*atanl(1))
#define dbl_PI (double)(4.*atanl(1))

const int CountOfStrDefault = 4; //      .   	 

struct fltParamOfMatrix {
	int N; //   
    int M; //  
	float hx; //  	  
	float hy; //  	  Y
	float limit; // 
	float eps; //  
	float *Result; //   
};

struct dblParamOfMatrix {
	int N;//   
	int M;//  
	double hx; //  	  
	double hy; //  	  Y
	double limit; // 
	double eps; //  
	double *Result; //   
};

struct cudaCompCapability {
	int major;
	int minor;
};

int  flt_input_from_file(fltParamOfMatrix *pm);
void flt_init_data_centr(float *u, int n, int m, float hx, float hy);
void flt_init_exact_solv(float *u_exact, int n, int m, float hx, float hy);
void flt_init_right_side (float *u, int n, int m, float hx, float hy);
void flt_print_matrix (float *mx, int n);
void flt_write_matrix_to_file (char *filename, float *mx, int n, int m);
int  dbl_input_from_file(dblParamOfMatrix *pm);
void dbl_init_data_centr(double *u, int n, int m, double hx, double hy);
void dbl_init_right_side (double *u, int n, int m, double hx, double hy);
void dbl_init_exact_solv(double *u_exact, int n, int m, double hx, double hy);
void dbl_print_matrix (double *mx, int n, int m);
void dbl_write_matrix_to_file (char *filename, double *mx, int n, int m);
