#include "DirixleDefinitions.h"

//     .
int dbl_input_from_file(dblParamOfMatrix *pm)
{
	FILE *fp; //   
	int CountOfLine = 0;  //
	int	er  = 0;
	if ((fp = fopen("Data.txt", "r")) != NULL) {	//    
		char s; //     
		while (!feof(fp)){ //    ,   
			er= fscanf(fp, "%s", &s);
			CountOfLine++;
		}
		if (CountOfLine == CountOfStrDefault) { //      
			rewind(fp); //    
			er =fscanf(fp, "%d", &pm->N           );
 			er =fscanf(fp, "%d", &pm->M           );
			er =fscanf(fp, "%lf", &pm->limit       );
			er =fscanf(fp, "%lf", &pm->eps         );			
            
			fclose(fp);
			if (pm->limit == 3.14) {
				pm->hx = dbl_PI/(double)(pm->N-1);
				pm->hy = dbl_PI/(double)(pm->N-1);
			}
			else {
				pm->hx = pm->limit/(double)(pm->N-1);
				pm->hy = pm->limit/(double)(pm->N-1);
			}
		}
		else {
			printf("Number of string in file not correct!\n\n");
			fclose(fp);
			return 0;
		}
	}
	else 
		printf("File not found\n");
	return 1;	
}

//  ,    ""    // !
void dbl_init_data_centr(double *u, int n, int m, double hx, double hy)
{
	int i, j;
    long k;
	hy= 0;
	double argsin, J = 0.;
	
	//      
	for (j = 0; j < n; ++j) {
		argsin = J*hx;
		u[j]   = sin(argsin);
		k      = n*(m-1) + j;
		u[k]   = -sin(argsin);
		J     += 1.;
	}
	J = 0.;
	//    
	for (j = 0; j < n; ++j)	{
		k = n*j;		
		u[k]   = 0.;
		k      = n*(j+1)-1;
		u[k]   = 0.;
	}

	for (i = 1; i < n-1; ++i)
		for (j = 1; j < m-1; ++j) {
			k    = n*i + j;
			u[k] = 0.;
		}
	return;
}

//   
void dbl_init_right_side (double *u, int n, int m, double hx, double hy)
{
	int i, j;
	long k;
	double argsin,argcos, I = 0., J = 0.;
	
	//      
	for (j = 0; j < n; ++j) {
		u[j]   = 0.;
		k      = n*(m-1) + j;
		u[k]   = 0.;
	}

	//    
	for (j = 0; j < n; ++j)	{
		argsin = I*hx;
		k      = n*j;		
		u[k]   = -2.*sin(argsin);
		k      = n*(j+1)-1;
		u[k]   = 2.*sin(argsin);
		I     += 1.;		
	}
	I = 1.;
	J = 1.;

	//  
	for (i = 1; i < n-1; ++i){
		for (j = 1; j < m-1; ++j) {
			k      = n*i + j; //    
			argsin = I*hy;
			argcos = J*hx;			
			u[k]   = -2.*cos(argcos)*sin(argsin);			
			J     += 1.;
		}
		I += 1.;
		J = 1.;
	}
    return;
}

//    
void dbl_init_exact_solv(double *u_exact, int n, int m, double hx, double hy)
{
	int i, j;
	long k;
	double argsin,argcos, I = 1., J = 1.;
	for (i = 1; i < n-1; ++i){
		for (j = 1; j < m-1; ++j)	{
			k          = n*i + j;
			argsin     = J*hx;
			argcos     = I*hy;			
			u_exact[k] = cos(argcos)*sin(argsin);
			J         += 1.;
		}
        I += 1.;
		J = 1.;
	}
	return;
}

/*  . */
void dbl_print_matrix (double *mx, int n, int m)
{
	int i, j;
	long k = 0;
	for (i = 0; i < n; ++i) {
		for ( j = 0; j < m; ++j){
			printf("%0*.*f\t", 1, 10, mx[k]);
			k++;
		}
		printf("\n");
	}
	return;
}

/*      Result.txt */
void dbl_write_matrix_to_file (char *filename, double *mx, int n, int m)
{
	FILE *fp;
	int i, j;
	long k = 0;
	if ((fp = fopen(filename, "w")) != NULL)
	{
		for (i = 0; i < n; ++i) {
			for ( j = 0; j < m; ++j){
				fprintf(fp,	"%0*.*f\t", 1, 10, mx[k]);
				k++;
			}
			fprintf(fp, "\n");
		}
		fclose(fp);
	}
	else
		printf("Can't open file!");
	
	return;
}
