#include "DirixleDefinitions.h"

//     .
int flt_input_from_file(fltParamOfMatrix *pm) {
	FILE *fp; //   
	int er =0;
	int CountOfLine = 0;  //
	if ((fp = fopen("Data.txt", "r")) != NULL) {	//    
		char s[100]; //     
		while (!feof(fp)){ //    ,   
			er =fscanf(fp, "%s", &s);
			CountOfLine++;
		}
		if (CountOfLine == CountOfStrDefault) { //      
			rewind(fp); //    
			er = fscanf(fp, "%d", &pm->N           );
			er =fscanf(fp, "%d", &pm->M           );
			er =fscanf(fp, "%f", &pm->limit       );
			er =fscanf(fp, "%f", &pm->eps         );			
            
			fclose(fp);
			if (pm->limit == 3.14) {
				pm->hx = flt_PI/(float)(pm->N-1);
				pm->hy = flt_PI/(float)(pm->M-1);
			}
			else {
				pm->hx = pm->limit/(float)(pm->N-1);
				pm->hy = pm->limit/(float)(pm->M-1);
			}
		}
		else {
			printf("Number of string in file not correct!\n\n");
			fclose(fp);
			return 0;
		}
	}
	else {
		printf("File not found\n");
		return 0;
	}
	return 1;
}

//  ,    ""    // !
void flt_init_data_centr(float *u, int n, int m, float hx, float hy)
{
	int i, j;
	long k;
	hy = 0; ///
	float argsin, J = 0.f;
	
	//      
	for (j = 0; j < n; ++j) {
		argsin = J*(float)hx;
		u[j]   = sin(argsin);
		k      = n*(m-1) + j;
		u[k]   = -sin(argsin);
		J     += 1.f;
	}
	J = 0.f;
	//    
	for (j = 0; j < m; ++j)	{
		k = n*j;		
		u[k]   = 0.f;
		k      = n*(j+1)-1;
		u[k]   = 0.f;
	}

	for (i = 1; i < n-1; ++i)
		for (j = 1; j < m-1; ++j) {
			k    = n*i + j;
			u[k] = 0.f;
		}
	return;
}


//   
void flt_init_right_side (float *u, int n, int m, float hx, float hy)
{
	int i, j, k;
	float argsin,argcos, I = 0.f, J = 0.f;
	
	//      
	for (j = 0; j < n; ++j) {
		u[j]   = 0.f;
		k      = n*(m-1) + j;
		u[k]   = 0.f;
	}

	//    
	for (j = 0; j < m; ++j)	{
		argsin = I*hx;
		k      = n*j;		
		u[k]   = -2.f*sin(argsin);
		k      = n*(j+1)-1;
		u[k]   = 2.f*sin(argsin);
		I     += 1.f;		
	}
	I = 1.f;
	J = 1.f;

	//  
	for (i = 1; i < n-1; ++i){
		for (j = 1; j < m-1; ++j) {
			k      = n*i + j; //    
			argsin = I*hy;
			argcos = J*hx;			
			u[k]   = -2.f*cos(argcos)*sin(argsin);			
			J     += 1.f;
		}
		I += 1.f;
		J = 1.f;
	}
    return;
}

//    
void flt_init_exact_solv(float *u_exact, int n, int m, float hx, float hy)
{
	int i, j, k;
	float argsin,argcos, I = 1.f, J = 1.f;
	for (i = 1; i < n-1; ++i){
		for (j = 1; j < m-1; ++j)	{
			k          = n*i + j;
			argsin     = J*(float)hx;
			argcos     = I*(float)hy;			
			u_exact[k] = cos(argcos)*sin(argsin);
			J         += 1.f;
		}
        I += 1.f;
		J = 1.f;
	}
	return;
}

/*  . */
void flt_print_matrix (float *mx, int n, int m)
{
	int i, j;
	long k = 0;
	for (i = 0; i < n; ++i) {
		for ( j = 0; j < m; ++j){
			printf("%0*.*f\t", 1, 6, mx[k]);
			k++;
		}
		printf("\n");
	}
	return;
}

/*      Result.txt */
void flt_write_matrix_to_file ( char *filename, float *mx, int n, int m)
{
	FILE *fp;
	int i, j;
	long k = 0;
	if ((fp = fopen(filename, "w")) != NULL)
	{
		for (i = 0; i < n; ++i) {
			for ( j = 0; j < m; ++j){
				fprintf(fp,	"%f\t", mx[k]);
				k++;
			}
			fprintf(fp, "\n");
		}
		fclose(fp);
	}
	else
		printf("Can't open file!");
	
	return;
}
